﻿/* Argow Mobile dotNet Interface (c) SAtelier 2010 */
using System;
using System.Collections.Generic;
using System.Runtime.InteropServices;
using System.Text;

namespace argow.utils {
  public static class mobile {
    [System.Runtime.InteropServices.DllImport("ArgowMobile.dll", CallingConvention = CallingConvention.StdCall, CharSet = CharSet.Unicode)]
    private static extern ushort mobile_getInfo( ushort nTimeOut, ushort nSize, IntPtr lpInfo );
    [System.Runtime.InteropServices.DllImport("ArgowMobile.dll", CallingConvention = CallingConvention.StdCall, CharSet = CharSet.Unicode)]
    private static extern int mobile_transfer( IntPtr lpSource, IntPtr lpDestiny, ushort bPcToMobile );

    public static Boolean getInfo(ref  System.Collections.Generic.Dictionary<string, string> oDic) {
      oDic.Clear();

      const ushort k = 1024;
      IntPtr pStr = Marshal.AllocCoTaskMem(k);
      try {
        for (int i = 0; i < k; i++) Marshal.WriteByte(pStr, i, (byte)0 );
        ushort iSize = mobile_getInfo( (ushort)100, k, pStr);
        if (iSize > 0) {
          string[] vBuffer = Marshal.PtrToStringUni(pStr, iSize).Split('\r');
          foreach (string cLine in vBuffer) {
              string[] vLine= cLine.Split('=');
              if (vLine.Length == 2 ) oDic.Add( vLine[0], vLine[1] );
          }
        }
      } finally {
        Marshal.FreeCoTaskMem(pStr);
      }
      return ( oDic.Count > 0 );
    }

    private static int transfer(string cSource, string cDestiny, bool bPcToMobile ) {
      const int ERROR_INVALID_NAME= 123;

      if ((cSource.Length == 0) || (cDestiny.Length == 0)) return ERROR_INVALID_NAME;
      int result= 0;
      IntPtr pSource = Marshal.StringToCoTaskMemUni(cSource);
      try{
        IntPtr pDestiny = Marshal.StringToCoTaskMemUni(cDestiny);
        try {
          result = mobile_transfer(pSource, pDestiny, Convert.ToUInt16(bPcToMobile) );
        } finally {
          Marshal.FreeCoTaskMem(pDestiny);
        }
      } finally {
        Marshal.FreeCoTaskMem(pSource);
      }
      return result;
    }

    public static int copyMobileToPc(string cSource, string cDestiny) {
      return transfer(cSource, cDestiny, false);
    }
    public static int copyPcToMobile(string cSource, string cDestiny) {
      return transfer(cSource, cDestiny, true);
    }

  }

}
